function options  = getTrainingOption()

optAlgo='sgdm';
Momentum=0.95; %start with 0.98
InitialLearnRate=10^-5;
LearnRateSchedule='piecewise';
LearnRateDropFactor=0.1;
LearnRateDropPeriod=10;
MaxEpochs=30;
Shuffle='once';
MiniBatchSize=64;
OutputFcn=@plotTrainingAccuracy;
CheckpointPath='temp';
ExecutionEnvironment= 'auto'; %parallel - gpu - cpu

options=trainingOptions(optAlgo,...
      'Momentum',Momentum,...
      'InitialLearnRate',InitialLearnRate,...
      'Shuffle',Shuffle,...
      'LearnRateSchedule',LearnRateSchedule,...
      'LearnRateDropFactor',LearnRateDropFactor,...
      'LearnRateDropPeriod',LearnRateDropPeriod,...
      'MaxEpochs',MaxEpochs,... 
      'MiniBatchSize',MiniBatchSize,...
      'CheckpointPath',CheckpointPath,...
      'OutputFcn',OutputFcn,...
      'ExecutionEnvironment',ExecutionEnvironment);